#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/kd.h>
#include <linux/fb.h>

static fb_fix_screeninfo finfo;
static fb_var_screeninfo vinfo;
static int fbdev_fd;

int main (int argc, char* argv[])
{
    char buf[128];
    int fbdev=0;

// usage fbres [fb-device]

    if(argc == 2)
        fbdev = atoi(argv[1]);

    sprintf(buf,"/dev/fb%d",fbdev);

    fbdev_fd = open(buf, O_RDWR);
//	if (fbdev_fd < 0)
//		fbdev_fd = open("/dev/fb/0", O_RDWR);

    if (fbdev_fd < 0)
    {
	fprintf(stderr, "can't open frame buffer device!\n");
	return 0;
    }
    
    fcntl(fbdev_fd, F_SETFD, fcntl(fbdev_fd, F_GETFD) | FD_CLOEXEC);
    ioctl(fbdev_fd, FBIOGET_FSCREENINFO, &finfo);
    ioctl(fbdev_fd, FBIOGET_VSCREENINFO, &vinfo);
    close(fbdev_fd);

    fprintf(stdout, "%d %d %d\n", vinfo.xres, vinfo.yres, vinfo.bits_per_pixel);

    return 0;
}
